linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Tom Zanussi <zanussi@kernel.org>
To: rostedt@goodmis.org
Cc: tglx@linutronix.de, mhiramat@kernel.org, namhyung@kernel.org,
	vedang.patel@intel.com, bigeasy@linutronix.de,
	joel@joelfernandes.org, mathieu.desnoyers@efficios.com,
	julia@ni.com, linux-kernel@vger.kernel.org,
	linux-rt-users@vger.kernel.org
Subject: [PATCH v8 09/22] tracing: Add hist trigger snapshot() action test case
Date: Mon, 10 Dec 2018 18:01:23 -0600	[thread overview]
Message-ID: <08e018fd4f7346435c36435d155f1aa8f9e7346d.1544483273.git.tom.zanussi@linux.intel.com> (raw)
In-Reply-To: <cover.1544483272.git.tom.zanussi@linux.intel.com>
In-Reply-To: <cover.1544483272.git.tom.zanussi@linux.intel.com>

From: Tom Zanussi <tom.zanussi@linux.intel.com>

Add a test case verifying the basic functionality of the
hist:snapshot() action.

Signed-off-by: Tom Zanussi <tom.zanussi@linux.intel.com>
---
 .../inter-event/trigger-snapshot-action-hist.tc    | 43 ++++++++++++++++++++++
 1 file changed, 43 insertions(+)
 create mode 100644 tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc

diff --git a/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc
new file mode 100644
index 000000000000..18fff69fc433
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc
@@ -0,0 +1,43 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: event trigger - test inter-event histogram trigger snapshot action
+
+fail() { #msg
+    echo $1
+    exit_fail
+}
+
+if [ ! -f set_event ]; then
+    echo "event tracing is not supported"
+    exit_unsupported
+fi
+
+if [ ! -f snapshot ]; then
+    echo "snapshot is not supported"
+    exit_unsupported
+fi
+
+grep -q "onchange(var)" README || exit_unsupported # version issue
+
+grep -q "snapshot()" README || exit_unsupported # version issue
+
+echo "Test snapshot action"
+
+echo 1 > /sys/kernel/debug/tracing/events/sched/enable
+
+echo 'hist:keys=comm:newprio=prio:onchange($newprio).save(comm,prio):onchange($newprio).snapshot() if comm=="ping"' >> /sys/kernel/debug/tracing/events/sched/sched_waking/trigger
+
+ping $LOCALHOST -c 3
+nice -n 1 ping $LOCALHOST -c 3
+
+echo 0 > tracing_on
+
+if ! grep -q "changed:" events/sched/sched_waking/hist; then
+    fail "Failed to create onchange action inter-event histogram"
+fi
+
+if ! grep -q "comm=ping" snapshot; then
+    fail "Failed to create snapshot action inter-event histogram"
+fi
+
+exit 0
-- 
2.14.1


  parent reply	other threads:[~2018-12-11  0:02 UTC|newest]

Thread overview: 33+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-12-11  0:01 [PATCH v8 00/22] tracing: Hist trigger snapshot and onchange additions Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 01/22] tracing: Refactor hist trigger action code Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 02/22] tracing: Make hist trigger Documentation better reflect actions/handlers Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 03/22] tracing: Add hist trigger handler.action documentation to README Tom Zanussi
2018-12-14 13:11   ` Masami Hiramatsu
2018-12-14 17:16     ` Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 04/22] tracing: Split up onmatch action data Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 05/22] tracing: Generalize hist trigger onmax and save action Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 06/22] tracing: Add conditional snapshot Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 07/22] tracing: Add hist trigger snapshot() action Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 08/22] tracing: Add hist trigger snapshot() action Documentation Tom Zanussi
2018-12-11  0:01 ` Tom Zanussi [this message]
2018-12-14 16:14   ` [PATCH v8 09/22] tracing: Add hist trigger snapshot() action test case Masami Hiramatsu
2018-12-11  0:01 ` [PATCH v8 10/22] tracing: Add hist trigger onchange() handler Tom Zanussi
2018-12-14 16:09   ` Masami Hiramatsu
2018-12-11  0:01 ` [PATCH v8 11/22] tracing: Add hist trigger onchange() handler Documentation Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 12/22] tracing: Add hist trigger onchange() handler test case Tom Zanussi
2018-12-14 16:18   ` Masami Hiramatsu
2018-12-14 17:17     ` Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 13/22] tracing: Add alternative synthetic event trace action syntax Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 14/22] tracing: Add alternative synthetic event trace action test case Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 15/22] tracing: Add hist trigger action 'expected fail' " Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 16/22] tracing: Add SPDX license GPL-2.0 license identifier to inter-event testcases Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 17/22] tracing: Remove unnecessary hist trigger struct fields Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 18/22] tracing: Use var_refs[] for hist trigger reference checking Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 19/22] tracing: Remove open-coding of hist trigger var_ref management Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 20/22] tracing: Use hist trigger's var_ref array to destroy var_refs Tom Zanussi
2018-12-14 16:31   ` Masami Hiramatsu
2018-12-14 17:29     ` Tom Zanussi
2018-12-15  6:50       ` Namhyung Kim
2018-12-15 21:01         ` Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 21/22] tracing: Remove hist trigger synth_var_refs Tom Zanussi
2018-12-11  0:01 ` [PATCH v8 22/22] tracing: Add hist trigger comments for variable-related fields Tom Zanussi

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=08e018fd4f7346435c36435d155f1aa8f9e7346d.1544483273.git.tom.zanussi@linux.intel.com \
    --to=zanussi@kernel.org \
    --cc=bigeasy@linutronix.de \
    --cc=joel@joelfernandes.org \
    --cc=julia@ni.com \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-rt-users@vger.kernel.org \
    --cc=mathieu.desnoyers@efficios.com \
    --cc=mhiramat@kernel.org \
    --cc=namhyung@kernel.org \
    --cc=rostedt@goodmis.org \
    --cc=tglx@linutronix.de \
    --cc=vedang.patel@intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).